<?php
/**
  * M2F Admin.
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version $Revision: 1.1 $
  * @internal $Id: admin_m2f_standalone.php,v 1.1 2005/03/04 01:37:15 georgeocrawford Exp $
*/


session_start();

//error_reporting  (E_ALL); // This will NOT report uninitialized variables
error_reporting  (E_ERROR | E_WARNING | E_PARSE); // This will NOT report uninitialized variables

// Include M2F functions
chdir('../');
require_once('./m2f_admin.php');

// start template system
chdir('./admin/');
require_once("./template.php");

$template_path = './templates' ;

$m2f_template = new m2fTemplate($template_path);

include('templates/page_header.php');


function m2f_message_die($message)
{
	global $m2f_template;
	$m2f_template->set_filenames(array(
			'body' => 'm2f_message_die.tpl')
	);    
	
	$m2f_template->assign_vars(array('message' => $message));
	page_header('admin_m2f_standalone.php');
	// Output the template
	$m2f_template->pparse('body');
	include('templates/page_footer.tpl');
	die;
}



if ($_SESSION['m2f_auth'] !== TRUE) 
{
	if (isset($_POST['password']))
	{
		if ($_POST['password'] == _M2F_STANDALONE_ADMIN_PASSWORD_)
		{
			$_SESSION['m2f_auth'] = TRUE;
		}
		else
		{
				// display login page, and bad password notification
				$m2f_template->set_filenames(array(
						'body' => 'm2f_admin_login.tpl')
				);
		 	 $m2f_template->assign_block_vars('switch_bad_password', array());
		}
	}
	else
	{
		// display login page
		$m2f_template->set_filenames(array(
				'body' => 'm2f_admin_login.tpl')
		);
	}
}

if ($_SESSION['m2f_auth'] === TRUE) 
{
	// Get current mode
	$mode = (isset($_POST['mode']) || isset($_GET['mode'])) ? ( isset($_POST['mode'])  ? $_POST['mode'] : $_GET['mode']) : '';
	
	// Depending on what we need to do...
	switch ($mode) {
		
		case 'email_subscriptions':
		
			$_POST['mailinglist_id'] = isset($_GET['mailinglist_id']) ? $_GET['mailinglist_id'] : $_POST['mailinglist_id'];
			$_POST['start'] = isset($_GET['start']) ? $_GET['start'] : $_POST['start'];
	
			if ($_POST['action'])
			{
				do_subscriptions_action($_POST['action']);
			}
			
			list($unsubscribed_groups, $subscribed_groups, $num_subscriptions, $is_board_subscribed, $ml_name) = get_subscriptions_info($_POST['mailinglist_id']);
	
			
			$m2f_template->set_filenames(array(
					'body' => 'm2f_email_subscriptions.tpl')
			);
			
			$m2f_template->assign_vars(array(
				'mailinglist_id' => $_POST['mailinglist_id'],
				'ml_name' => $ml_name
			));
			
			
			$subscriptions = get_email_subscriptions_info($_POST['mailinglist_id']);
			
			$results_per_page = 20;
			$start = $_POST['start'] ? $_POST['start'] : 0;
			
			if(count($subscriptions) != 0) 
			{
				if (count($subscriptions) == $start) $start = $start - $results_per_page;
				
				$m2f_template->assign_block_vars('switch_subscriptions', array());
				$m2f_template->assign_vars(array(
					'start' => $start
				));
					
				for ($i=$start; $i<$start+$results_per_page; $i++)
				{
					if ($subscriptions[$i]) $m2f_template->assign_block_vars('switch_subscriptions.subscriptions', array('username' => $subscriptions[$i]['username'], 'user_id' => $subscriptions[$i]['user_id']));
				}
			} 
			else
			{
				$m2f_template->assign_vars(array(
					'start' => $start
				));
			}
			
			if(count($subscriptions) > $results_per_page) 
			{
				$pagination = m2f_generate_pagination("admin_m2f_standalone.php?mode=email_subscriptions&ml_name=$ml_name&mailinglist_id=$_POST[mailinglist_id]", count($subscriptions), $results_per_page, $start);
				$m2f_template->assign_block_vars('switch_pagination', array(
					'pagination' => $pagination, 
				));
			}
	
		break;
		
		// ---------------------------------------------------------------------------------
		
		case 'subscriptions':
	
			if (isset($_GET['mailinglist_id'])) $_POST['mailinglist_id'] = $_GET['mailinglist_id'];
			
			if ($_POST['action'])
			{
				do_subscriptions_action($_POST['action']);
			}
			
			$m2f_template->set_filenames(array(
				'body' => 'm2f_subscriptions.tpl')
				);
			
			list($unsubscribed_groups, $subscribed_groups, $num_subscriptions, $is_board_subscribed, $ml_name) = get_subscriptions_info($_POST['mailinglist_id']);
	
			// if there are some possible groups to subscribe to, display them:
			if (!empty($unsubscribed_groups))
			{
				$m2f_template->assign_block_vars('switch_subscribe_group', array());
				$m2f_template->assign_vars(array(
					'S_GROUP_SELECT' => $unsubscribed_groups
				));
			}
	
			// display currently subscribed groups
			if (!empty($subscribed_groups))
			{
				$m2f_template->assign_block_vars('switch_subscribed_groups', array());
				foreach ($subscribed_groups as $group)
				{
					$m2f_template->assign_block_vars('switch_subscribed_groups.subscribed_groups', array(
					'group_id' => $group['group_id'],
					'group_name' => $group['group_name']
					));
				}
			}
	
			(intval($is_board_subscribed) == 1) ? $m2f_template->assign_block_vars('switch_unsubscribe_board', array()) : $m2f_template->assign_block_vars('switch_subscribe_board', array());
			
			$m2f_template->assign_vars(array(
				'S_M2F_ACTION' => 'admin_m2f_standalone.php',
				'start' => '0',
				'mailinglist_id' => $_POST['mailinglist_id'],
				'num_subscriptions' => $num_subscriptions,
				'ml_name' => $ml_name	
			));
		
		break;
	
		// ---------------------------------------------------------------------------------
	
		case 'mailinglists':
		
			if (($_POST['action'] == 'Edit') && (!isset($_POST['edited'])))
			{
				$mailinglists = get_mailinglists();
				
				$m2f_template->set_filenames(array(
					'body' => 'm2f_edit_mailinglist.tpl')
				);
		
				$m2f_template->assign_vars(array(
							'S_M2F_ACTION' => 'admin_m2f_standalone.php',
							'list_email' => $mailinglists[$_POST['mailinglist_id']]['list_email'],
							'mailinglist_id' => $_POST['mailinglist_id'],
							'ml_name' => $mailinglists[$_POST['mailinglist_id']]['name']
							));
													
				break;
			}
	
			if ($_POST['action'])
			{
				do_mailinglist_action($_POST['action']);
			}
			
			$m2f_template->set_filenames(array(
				'body' => 'm2f_mailinglists.tpl')
				);
	
			$mailinglists = get_mailinglists();
				
			if (count($mailinglists) != 0) 
			{
				$m2f_template->assign_block_vars('switch_mailinglists', array());
	
				foreach ($mailinglists as $mailinglist_id => $mailinglist_details)
				{
					$m2f_template->assign_block_vars('switch_mailinglists.mailinglists', array(
					'mailinglist_id' => $mailinglist_id,
					'num_subscriptions' => $mailinglist_details['num_subscriptions'],
					'num_group_subscriptions' => $mailinglist_details['num_group_subscriptions'],
					'board_subscribed' => ($mailinglist_details['board_subscribed'] == 1) ? '<span style="color:#FFA34F">Yes</span>' : 'No',
					'name' => $mailinglist_details['name'],
					'list_email' => $mailinglist_details['list_email'],
					'mbox_file' => $mailinglist_details['mbox_file'],
					'status' => $mailinglist_details['status'],
					'action' => ( $mailinglist_details['status']==0 ? 'Activate' : 'Deactivate')
					));
				}
			}
			
		break;
	
		// ---------------------------------------------------------------------------------
	
		case 'distributionlists':
		case 'default_distribution':
			if (isset($_POST['Configure']) || ($mode == 'default_distribution'))
			{
				
				if (isset($_POST['save_settings']) || isset($_POST['test_smtp']) || isset($_POST['test_mbox']) || isset($_POST['test_pop']))
				{
					configure_dist_list();
		
					if (isset($_POST['save_settings']))
					{
						$message = 'Your ' . ($mode == 'default_distribution' ? 'default ' : '') . 'distribution list settings have been saved.' . "<br /><br />" . sprintf('Click %shere%s to return to ' . ($mode == 'default_distribution' ? 'Settings' : 'Distribution Lists') , "<a href=\"" . ($mode == 'default_distribution' ? "admin_m2f_standalone.php?mode=settings" : "admin_m2f_standalone.php?mode=distributionlists") . "\">", "</a>");
						m2f_message_die($message);
					}
				}
				
				$m2f_template->set_filenames(array(
						'body' => 'm2f_distributionlist_settings.tpl')
				);
				
				// Get configs
				$params = get_dist_list_settings();
				
				$m2f_template->assign_vars($params);
				
				$m2f_template->assign_vars(array(
				'SMTP_RESULTS' => (isset($_POST['test_smtp'])) ? '<br /><br /><span style="color:#FFA34F" class="gen">&nbsp;&nbsp;&nbsp;SMTP connect results:<br /><ul>' . test_smtp() . '</ul></span>' : '',
				'MBOX_RESULTS' => (isset($_POST['test_mbox'])) ? '<br /><br /><span style="color:#FFA34F" class="gen">&nbsp;&nbsp;&nbsp;Mbox path test results:<br /><ul>' . test_mbox() . '</ul></span>' : '',
				'POP_RESULTS' => (isset($_POST['test_pop'])) ? '<br /><br /><span style="color:#FFA34F" class="gen">&nbsp;&nbsp;&nbsp;POP connect results:<br /><ul>' . test_pop() . '</ul></span>' : ''
				));
			} 
			
			// -------------------------------------
			// Distribution Lists overview page
			else 
			{
				$mailinglists = get_mailinglists();
				if (count($mailinglists) == 0) {
					$message = sprintf('You must create a mailing list before you can set up a distribution.<br><br> Click %shere%s to go the the Mailing Lists page' , "<a href=\"admin_m2f_standalone.php?mode=mailinglists\">", "</a>");
					m2f_message_die($message);
				}
	
				$m2f_template->set_filenames(array(
						'body' => 'm2f_distributionlists.tpl')
				);
				
				if (@$_POST['action'])
				{
					do_dist_lists_action($_POST['action']);
				}
	
				if (isset($_POST['Delete']))
				{
					do_dist_lists_action('Delete');
				}
				
				if (isset($_POST['Add']))
				{
					do_dist_lists_action('Add');
				}
				
				// Find as yet unlinked forums and mailinglists
				$unlinked_forums = get_forums();
				$unlinked_mailinglists = get_unlinked_mailinglists();
				
				if ((count($unlinked_forums) != 0) && (count($unlinked_mailinglists) != 0))
				{
					$m2f_template->assign_block_vars('switch_possible_combos', array());
						
					if($unlinked_forums)
					{						
						foreach ($unlinked_forums as $forum_details)
						{
							$m2f_template->assign_block_vars('switch_possible_combos.forums', array(
							'forum_id' => $forum_details['forum_id'],
							'forum_name' => $forum_details['forum_name']
							 ));
						}
					}
					
					if($unlinked_mailinglists)
					{
						foreach ($unlinked_mailinglists as $mailinglist_details)
						{
							$m2f_template->assign_block_vars('switch_possible_combos.mailinglists', array(
							'mailinglist_id' => $mailinglist_details['mailinglist_id'],
							'list_email' => $mailinglist_details['list_email'],
							'name' => $mailinglist_details['name'],
						));
						}
					}
				}
				else
				{
					$m2f_template->assign_block_vars('switch_no_possible_combos', array());
				}
				
				// Setup distributionlist vars
				$distributionlists = get_dist_lists();
				
				if (count($distributionlists) != 0) 
				{
					$m2f_template->assign_block_vars('switch_distributionlists', array());
	
					foreach ($distributionlists as $distributionlist_id => $distributionlist_details)
					{
						$m2f_template->assign_block_vars('switch_distributionlists.distributionlists', $distributionlist_details);
					}
				}
			}    
			
		break;
		
	
		// ---------------------------------------------------------------------------------
		case 'tools':
			
			if (isset($_POST['force_import']))
			{
				$phpbb_root_path = '../../';
				define('IN_PHPBB', TRUE);
				include_once($phpbb_root_path . 'extension.inc');
				include_once($phpbb_root_path . 'common.php');
				
				
				include_once($phpbb_root_path . 'includes/bbcode.php');
				include_once($phpbb_root_path . 'includes/functions_post.php');
				include_once($phpbb_root_path . 'includes/functions_search.php');
				$message = force_import();
				
				$message .= '<form action="';
				$message .= 'admin_m2f_standalone.php';
				$message .= '" method="POST"><input type="hidden" name="mode" value="tools"><input type="submit" name="force_import" value="Force Import Again"></form><br /><br /><br />';
	
				$message .= sprintf('Click %sHere%s to return to Mail 2 Forum Tools' , "<a href=\"admin_m2f_standalone.php?mode=tools" . "\">", "</a>");
				
				m2f_message_die($message);
			}
			
			switch (_M2F_LOG_METHOD_)
			{
			case 'FILE':
				if (isset($_GET['iframe']))
				{
					$log_file = get_log_file();
					$m2f_template->set_filenames(array(
						'body' => 'm2f_tools_iframe.tpl')
					);
					
					$m2f_template->assign_block_vars('switch_view_log_file', array());
					
					$m2f_template->assign_vars(array(
						'log_file' => $log_file
						));
					
					$m2f_template->pparse('body');
					echo '</body></html>';
					die;
				}
				else
				{
					$m2f_template->set_filenames(array(
						'body' => 'm2f_tools.tpl')
					);
					
					$m2f_template->assign_block_vars('switch_view_log_file', array());
					
					$url = 'admin_m2f_standalone.php?mode=tools&iframe=1';
					
					if (isset($_POST['view_complete_log'])) $url .= '&view_complete_log=1';
					
					$m2f_template->assign_vars(array(
						'_M2F_IFRAME_URL_' => $url
						));
				}
				
				break;
				
			case 'DATABASE':
			default:
				if (isset($_POST['erase_log']))
				{
					erase_db_log();
					$message = 'The Mail2Forum database log was successfully erased.' . "<br /><br />" . sprintf('Click %shere%s to return to Mail 2 Forum Tools' , "<a href=\"admin_m2f_standalone.php?mode=tools\">", "</a>");
					m2f_message_die($message);
				}
				else if (isset($_GET['iframe']))
				{
					$log_levels = array('emergency', 'alert', 'critical', 'error', 'warning', 'notice', 'info', 'debug');
					$db_result = get_db_log();
	
					$m2f_template->set_filenames(array(
						'body' => 'm2f_tools_iframe.tpl')
					);
					
					if (count($db_result) > 0)
					{
						$m2f_template->assign_block_vars('switch_view_log_database', array());
						foreach ($db_result as $result_row)
						{
							$m2f_template->assign_block_vars('switch_view_log_database.database_line', array(
							'time' => $result_row['logtime'],
							'level' => $log_levels[($result_row['priority'])],
							'message' => $result_row['message']
							 ));
						}
	
					}
					else
					{
						$m2f_template->assign_block_vars('switch_nothing', array());
					}
					page_header('admin_m2f_standalone.php', TRUE);
					// Output the template
					$m2f_template->pparse('body');
					echo '</body></html>';
					die;
				}
				else
				{
					$m2f_template->set_filenames(array(
						'body' => 'm2f_tools.tpl')
					);
					
					$m2f_template->assign_block_vars('switch_view_log_file', array());
					
					$url = 'admin_m2f_standalone.php?mode=tools&iframe=1';
					$url .= add_to_url();
	
					$m2f_template->assign_vars(array(
						'_M2F_IFRAME_URL_' => $url
						));
						
					$m2f_template->assign_block_vars('switch_database_log', array());
					
					if (isset($_POST['view_log_period'])) $m2f_template->assign_vars(array('_M2F_LOG_DATE_FROM_' => date_from(), '_M2F_LOG_DATE_TO_' => date_to() ));
					else $m2f_template->assign_vars(array('_M2F_LOG_DATE_FROM_' => date_yesterday(), '_M2F_LOG_DATE_TO_' => date_today() ));
				}
				break;
		}
		break;
		
		
		// ---------------------------------------------------------------------------------
		case 'settings':
	
			if (isset($_POST['save_settings']))
			{
				save_m2f_settings();
				$message = 'Your Mail 2 Forum settings have been saved.' . "<br /><br />" . sprintf('Click %shere%s to return to Mail 2 Forum Settings' , "<a href=\"admin_m2f_standalone.php?mode=settings\">", "</a>");
				m2f_message_die($message);
			}
			
			$m2f_template->set_filenames(array(
					'body' => 'm2f_settings.tpl')
			);    
			
			$m2f_template->assign_vars(get_m2f_settings());
			
		break;
		
		// ---------------------------------------------------------------------------------
		default:
			$m2f_template->set_filenames(array(
					'body' => 'm2f_overview.tpl')
			);    
		break;
	}
}
///////////////////////////////////////////////////////////////////////////////////////


// SID constant
$m2f_template->assign_vars(array('S_M2F_ACTION' => 'admin_m2f_standalone.php?'));

page_header('admin_m2f_standalone.php');

// Output the template
$m2f_template->pparse('body');

include('templates/page_footer.tpl');

?>