<?php
/**
  * Update m2f database schema to version 11
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version
  * @internal
*/



function m2f_update_schema_11($type_db)
{
	global $m2f_db;
 	m2f_log(PEAR_LOG_NOTICE , "Updating M2F tables to DB version 11" , __LINE__ , __FILE__);

	// Add the new post_id and reason columns to the message moderation table
	switch ($type_db)
	{
		case 'mysql':
			$sql = "ALTER TABLE " . _M2F_MODERATED_MSGS_TABLE_ . "
							ADD COLUMN (post_id mediumint(8) NOT NULL default '0', reason varchar(15) default NULL)";
			break;

		case 'pgsql':
			$sql = "ALTER TABLE " . _M2F_MODERATED_MSGS_TABLE_ . "
							ADD COLUMN (post_id INTEGER NOT NULL default 0, reason varchar(15) default NULL)";
			break;
	}
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);


	// Update version number
	$sql = "UPDATE " . _M2F_CONFIG_TABLE_ . "
	     		SET config_value = 11
	     		WHERE config_name = '_M2F_DB_VERSION_'";
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	m2f_log(PEAR_LOG_NOTICE , "Updated DB version to 11" , __LINE__ , __FILE__ );


	return TRUE;
}

?>