<?php
/**
  * Update m2f database schema to version 12
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version
  * @internal
*/



function m2f_update_schema_12($type_db)
{
	global $m2f_db;
 	m2f_log(PEAR_LOG_NOTICE , "Updating M2F tables to DB version 12" , __LINE__ , __FILE__);

	// make sure moderated messages table is correct format. No changes for PostgreSQL
	switch ($type_db)
	{
		case 'mysql':
			$sql = array();
			$sql[] = "ALTER TABLE " . _M2F_MODERATED_MSGS_TABLE_ . " CHANGE topic_id topic_id mediumint(8) NOT NULL default '0'";
			$sql[] = "ALTER TABLE " . _M2F_MODERATED_MSGS_TABLE_ . " CHANGE post_id post_id mediumint(8) NOT NULL default '0'";
			$sql[] = "ALTER TABLE " . _M2F_MODERATED_MSGS_TABLE_ . " CHANGE user_id user_id mediumint(8) NOT NULL default '0'";
			
			foreach ($sql as $query)
			{
				$db_result = $m2f_db->query($query);
				check_db_result($db_result, $query, __LINE__, __FILE__);
			}
			
			break;
	}
	
	// Update version number
	$sql = "UPDATE " . _M2F_CONFIG_TABLE_ . "
	     		SET config_value = 12
	     		WHERE config_name = '_M2F_DB_VERSION_'";
	$db_result = $m2f_db->query($sql);
	check_db_result($db_result, $sql, __LINE__, __FILE__);
	m2f_log(PEAR_LOG_NOTICE , "Updated DB version to 12" , __LINE__ , __FILE__ );


	return TRUE;
}

?>