<?php
/**
  * Simple cron utility.
  *
  * @author Patricio Anguita
  * @license http://opensource.org/licenses/gpl-license.php GNU Public License
  * @version $Revision: 1.5 $
  * @internal $Id: m2f_cron.php,v 1.5 2006/08/03 16:25:42 georgeocrawford Exp $
*/
if (isset($_POST['m2f_root_path']) || isset($_GET['m2f_root_path']) || isset($_COOKIE['m2f_root_path'])) die ('Hacking attempt');

include_once (M2F_ROOT_PATH . 'm2f_common.php');

// Abstract forum class
class m2f_cron
{

	function run()
	{
		global $m2f_handler;
		
		// Get next scheduled cron run
		m2f_log(PEAR_LOG_INFO , "Running check for automated M2F-Cron" , __LINE__ , __FILE__ );
		
	  $db_result = $this->latest_cron();
	  $latest_timestamp = $db_result['logtime'];
	  $current_timestamp = time();
	  
	  m2f_log(PEAR_LOG_DEBUG , "Latest cron" , __LINE__ , __FILE__ ,$db_result);
	  m2f_log(PEAR_LOG_DEBUG , "Current_timestamp" , __LINE__ , __FILE__ ,$current_timestamp);
	  
		// Is it time to run the job?
		if (($current_timestamp - $latest_timestamp)/60 > _M2F_CRON_DELAY_)
		{
			// Insert current cron job
			$cron_id = $this->new_cron();
			
			// Run the importing routine
			m2f_log(PEAR_LOG_INFO , "Running import_msgs from M2F-Cron" , __LINE__ , __FILE__ );
			$results_array = $m2f_handler->import_msgs();
			
			// Update the cron job
			$this->update_cron($cron_id, addslashes(serialize($results_array)),1);
			
			// Done
		}
	}
	
	// Returns latest cron's data
	function latest_cron()
	{
		global $m2f_db;
		
		$sql = "SELECT * FROM " . _M2F_CRON_TABLE_ . "
	      			ORDER BY cron_id DESC LIMIT 1"; 
		$db_result = $m2f_db->getRow($sql);
	  check_db_result($db_result, $sql, __LINE__, __FILE__);
	  
	  return $db_result;
	}
	
	// Create a new cron log
	function new_cron()
	{
		global $m2f_db;
		
		$sql = "INSERT INTO " . _M2F_CRON_TABLE_ . "
	      			(logtime , results, status)
	      			VALUES ('" . time() . "', '' , 0)"; 
		$db_result = $m2f_db->query($sql);
	  check_db_result($db_result, $sql, __LINE__, __FILE__);
	  
	  // Todo: Find out a better way to do this with pear
	  // Get the new id created
	  $this_cron = $this->latest_cron();
	  return $this_cron['cron_id'];
	}
	
	// Update the cron log
	function update_cron($cron_id, $results, $status)
	{
		global $m2f_db;
		
		$sql = "UPDATE " . _M2F_CRON_TABLE_ . " SET
	      			results ='$results', status = $status
	      			WHERE cron_id = $cron_id"; 
		$db_result = $m2f_db->query($sql);
	  check_db_result($db_result, $sql, __LINE__, __FILE__);
	  
	  return $db_result;
	}
}

?>