
<script type="text/javascript" language="javascript">
	 function Toggle(e) {
		 var b = (document.getElementById(e).style.display == "none");
		 Change(e, b);
	 }
	 function Change(e, b) {
		 var o = document.getElementById(e);
		 o.style.display = (b ? "block" : "none");
	 }
	 function Restore() {
		 for (i = 0; i < Restore.arguments.length; i++) {
			 Change(Restore.arguments[i], ("no" == "yes"));
		 }
	 }
</script>

<h1>Mail 2 Forum Pattern Matching: Strip or Replace</h1>

<!-- BEGIN switch_intro -->
<p><b>Introduction</b><br />
On this page, you can set 'patterns' of text to search and replace in incoming emails. These patterns can be useful in a number of ways. You may for example be using an external Mailing List Server such as Yahoo Groups, which adds adverts or links to the bottom of your emails. <i>You may link your patterns to a distribution list on the <a href="{switch_intro.dist_list_link}">Distribution Lists configuration</a> page</i>.</p>
<!-- END switch_intro -->

<p class="gen" id="link" style="display: none"><a href="javascript:Toggle('instructions')">Click to view instructions</a></p>

<div id="instructions">
	<p><b>Simple</b><br />
	Mail2Forum will perform a different kind of search for each pattern, depending on your preference. This is set by checking or unchecking the "Use Regular Expressions?" box. If you want to simply remove a short, fixed word, phrase or set of characters, turn the "Use Regular Expressions?" option off. This will perform a <a href="http://www.php.net/str_replace" target="_blank">str_replace()</a> call, replacing the matched text with the contents of the 'Replace Pattern' field (which can of course be blank to simply delete the text).</p>
	
	<p><b>Advanced</b><br />
	For advanced users, turning the "Use Regular Expressions?" option on allows much greater flexibility, inclusing the possibility of matching dynamically changing patterns. Mail2Forum will use a <a href="http://www.php.net/preg_replace" target="_blank">preg_replace()</a> call - the syntax is exactly as described on php.net's <a href="http://www.php.net/manual/en/reference.pcre.pattern.syntax.php" target="_blank">Pattern Syntax</a> page. You may additionally specify pattern modifiers. These may include any from the <a href="http://www.php.net/manual/en/reference.pcre.pattern.modifiers.php" target="_blank">Pattern Modifiers</a> list except the <span class="code">e</span> modifier which executes the replacement as PHP code. </p>
	
	<p><b>Target</b><br />
	For each pattern, you may specify where to perform the search and replace - in the Body of the email, or the Subject, or both. You may also test each pattern against sample input text of your choosing.</p>
	
	<p><b>Escape your pattern</b> (regexp patterns only)<br />
	NB. that the search pattern for preg_replace() calls is put within <span class="code">/</span> and <span class="code">/</span> delimiters, so the search string assembly looks something like this: <br /><br />
	<span class="code">$search = '/' . $pattern . '/' . $modifiers;</span><br /><br />
	<i>You must ensure to escape <span class="code">/</span> symbols in the search pattern as necessary.</i></p>
</div>
<br />

<script type="text/javascript" language="javascript">
	Restore('instructions');
	Toggle('link');
</script>

<!-- BEGIN switch_edit -->
<form action="{S_M2F_ACTION}" method="POST">
	<input type="hidden" name="mode" value="pattern_matching" />
	<input type="hidden" name="id" value="{switch_edit.id}" />
	<table width="99%" cellpadding="4" cellspacing="2" border="0" align="center" class="forumline">
		<tr>
			<th>Description</th>
			<th>Search Pattern</th>
			<th>Replace Pattern</th>
			<th>Use Regular Expressions?</th>
			<th>Pattern Modifiers</th>
			<th>Replace Target</th>
		</tr>
		<tr align="center">
			<td class="row1"><textarea class="post" cols="20" rows="7" name="description">{switch_edit.description}</textarea></td>
			<td class="row2"><textarea class="post code" cols="35" rows="7" name="match">{switch_edit.match}</textarea></td>
			<td class="row1"><textarea class="post code" cols="25" rows="7" name="replace">{switch_edit.replace}</textarea></td>
			<td class="row2"><input type="checkbox" name="use_regexp" value='1' {switch_edit.use_regexp} /></td>
			<td class="row2"><input type="text" name="modifiers" value='{switch_edit.modifiers}' size="8" /></td>
			<td class="row2" align="right">
				Subject <input type="checkbox" name="target[]" value="1" {switch_edit.target_subject}><br />
				Body <input type="checkbox" name="target[]" value="2" {switch_edit.target_body}><br />
			</td>
		</tr>
		<tr>
			<td class="catBottom" colspan="6" align="center">
				<input type="submit" name="action" value="Submit Edited Pattern" class="mainoption" />
				<input type="submit" value="Cancel" class="mainoption" />
			</td>
		</tr>
	</table>
</form>
<!-- END switch_edit -->

<!-- BEGIN switch_test -->
<form action="{S_M2F_ACTION}" method="POST">
	<input type="hidden" name="mode" value="pattern_matching" />
	<input type="hidden" name="id" value="{switch_test.id}" />
	<table width="99%" cellpadding="4" cellspacing="2" border="0" align="center" class="forumline">
		<tr>
			<th>Description</th>
			<th>Search Pattern</th>
			<th>Replace Pattern</th>
			<th>Use Regular Expressions?</th>
			<th>Pattern Modifiers</th>
			<th>Replace Target</th>
		</tr>
		<tr align="center">
			<td class="row1"><textarea class="post" cols="20" rows="7" name="description">{switch_test.description}</textarea></td>
			<td class="row2"><textarea class="post code" cols="35" rows="7" name="match">{switch_test.match}</textarea></td>
			<td class="row1"><textarea class="post code" cols="25" rows="7" name="replace">{switch_test.replace}</textarea></td>
			<td class="row2"><input type="checkbox" name="use_regexp" value='1' {switch_test.use_regexp} /></td>
			<td class="row2"><input type="text" name="modifiers" value='{switch_test.modifiers}' size="8" /></td>
			<td class="row2" align="right">
				Subject <input type="checkbox" name="target[]" value="1" {switch_test.target_subject}><br />
				Body <input type="checkbox" name="target[]" value="2" {switch_test.target_body}><br />
			</td>
		</tr>
		<tr align="center">
			<td class="row1" colspan="6"><textarea class="post" cols="100" rows="15" name="sample">{switch_test.sample}</textarea></td>
		</tr>
		<tr>
			<td class="catBottom" colspan="6" align="center"><input type="submit" name="action" value="Test Pattern" class="mainoption" />&nbsp;&nbsp;&nbsp;<input type="submit" name="action" value="Save" class="mainoption" /></td>
		</tr>
		<tr>
			<td class="row2" colspan="6" align="left">
			<p>Your test results will be displayed twice. Firstly, as if they were HTML, with the Search pattern in blue and crossed-through and the Replace pattern in red. Secondly, in plain text format, with the Search pattern deleted and the Replace pattern inserted. This second result uses the same operation that M2F will perform on imported emails.</p>
			{switch_test.results}</td>
		</tr>
	</table>
</form>
<!-- END switch_test -->

<!-- BEGIN switch_eval_modifier -->
<table class="forumline" width="100%" cellspacing="1" cellpadding="4" border="0">
	<tr align="center">
		<td><table width="60%" cellspacing="0" cellpadding="1" border="0">
			<tr>
				<td align="center">
					<span class="gen">
						Unfortunately, we can't allow the <span class="code">&nbsp;e&nbsp;</span> modifier at the moment, as Georgec can't find a way to test for a valid replace string. Sorry!<br /><br />
						You need to <a href="javascript:history.back()">go back</a> and remove the modifier.
					</span>
				</td>
			</tr>
		</table></td>
	</tr>
</table>
<br /><br />
<!-- END switch_eval_modifier -->

<!-- BEGIN switch_blank_search_string -->
<table class="forumline" width="100%" cellspacing="1" cellpadding="4" border="0">
	<tr align="center">
		<td><table width="60%" cellspacing="0" cellpadding="1" border="0">
			<tr>
				<td align="center">
					<span class="gen">
						The search string was blank. This is not allowed, as it may cause all text to be removed!<br /><br />
						You need to <a href="javascript:history.back()">go back</a> and add a search string.
					</span>
				</td>
			</tr>
		</table></td>
	</tr>
</table>
<br /><br />
<!-- END switch_blank_search_string -->

<!-- BEGIN switch_no_target -->
<table class="forumline" width="100%" cellspacing="1" cellpadding="4" border="0">
	<tr align="center">
		<td><table width="60%" cellspacing="0" cellpadding="1" border="0">
			<tr>
				<td align="center">
					<span class="gen">
						You must select at least one target area to perform the search.<br /><br />
						You need to <a href="javascript:history.back()">go back</a> and check one of the target boxes.
					</span>
				</td>
			</tr>
		</table></td>
	</tr>
</table>
<br /><br />
<!-- END switch_no_target -->

<!-- BEGIN switch_bad_modifiers -->
<table class="forumline" width="100%" cellspacing="1" cellpadding="4" border="0">
	<tr align="center">
		<td><table width="60%" cellspacing="0" cellpadding="1" border="0">
			<tr>
				<td align="center">
					<span class="gen">
						You have entered one or more invalid pcre pattern modifiers. The following are not recognised: <span class="code">&nbsp;{switch_bad_modifiers.modifiers}&nbsp;</span><br /><br />
						You need to <a href="javascript:history.back()">go back</a> and edit the modifiers.<br /><br />
						You may want to check the <a href="http://www.php.net/manual/en/reference.pcre.pattern.modifiers.php" target="_blank">manual</a> to see the complete list of pattern modifiers. Mail2Forum currently allows all except the 'e' modifier.
					</span>
				</td>
			</tr>
		</table></td>
	</tr>
</table>
<br /><br />
<!-- END switch_bad_modifiers -->

<!-- BEGIN switch_bad_search_pattern_edit -->
<table class="forumline" width="100%" cellspacing="1" cellpadding="4" border="0">
	<tr align="center">
		<td><table width="60%" cellspacing="0" cellpadding="1" border="0">
			<tr>
				<td align="center"><span class="gen">
					The pattern <span class="code">&nbsp;{switch_bad_search_pattern_edit.match}&nbsp;</span> is not valid pcre syntax for the search string.<br /><br />
					The errors returned were:<br />
					<span class="code">&nbsp;{switch_bad_search_pattern_edit.errors}&nbsp;</span><br /><br />
					You need to <a href="javascript:history.back()">go back</a> and correct the mistake.<br /><br />
					You may want to check the <a href="http://www.php.net/manual/en/reference.pcre.pattern.modifiers.php" target="_blank">manual</a>, or just uncheck the "Use Regular Expressions?"<br />box for a simple find-and-replace.</span></td>
			</tr>
		</table></td>
	</tr>
</table>
<br /><br />
<!-- END switch_bad_search_pattern_edit -->

<!-- BEGIN switch_patterns -->
<form action="{S_M2F_ACTION}" method="POST">
	<input type="hidden" name="mode" value="pattern_matching" />
	<table width="99%" cellpadding="4" cellspacing="2" border="0" align="center" class="forumline">
		<tr>
			<th>Description</th>
			<th>Search Pattern</th>
			<th>Replace Pattern</th>
			<th>Use Regular Expressions?</th>
			<th>Pattern Modifiers</th>
			<th>Replace Target</th>
		</tr>
		<tr align="center">
			<td class="row1"><textarea class="post" cols="20" rows="7" name="description"></textarea></td>
			<td class="row2"><textarea class="post code" cols="35" rows="7" name="match"></textarea></td>
			<td class="row1"><textarea class="post code" cols="25" rows="7" name="replace"></textarea></td>
			<td class="row2"><input type="checkbox" name="use_regexp" value='1' /></td>
			<td class="row2"><input type="text" name="modifiers" size="8" /></td>
			<td class="row2" align="right">
				Subject <input type="checkbox" name="target[]" value="1" CHECKED><br />
				Body <input type="checkbox" name="target[]" value="2" CHECKED><br />
			</td>
		</tr>
		<tr>
			<td class="catBottom" colspan="6" align="center"><input type="submit" name="action" value="Add a new pattern" class="mainoption" /></td>
		</tr>
	</table>
</form>

<br />


<table width="99%" cellpadding="4" cellspacing="2" border="0" align="center" class="forumline">
	<tr>
		<th colspan="3">Action</td>
		<th>Description</th>
		<th>Search Pattern</th>
		<th>Replace Pattern</th>
		<th>Use Regular Expressions?</th>
		<th>Pattern Modifiers</th>
		<th>Replace Target</th>
	</tr>
 <!-- BEGIN patterns -->
	<tr>
		<td align="center" class="row1">
			<form action="{S_M2F_ACTION}" method="POST">
			<input type="hidden" name="mode" value="pattern_matching" />
			<input type="hidden" name="id" value="{switch_patterns.patterns.id}" />
			<input type="submit" name="action" value="Test" class="mainoption" />
			</form>
		</td>
		<td align="center" class="row1">
			<form action="{S_M2F_ACTION}" method="POST">
			<input type="hidden" name="mode" value="pattern_matching" />
			<input type="hidden" name="id" value="{switch_patterns.patterns.id}" />
			<input type="submit" name="action" value="Edit" class="mainoption" />
			</form>
		</td>
		<td align="center" class="row1">
			<form action="{S_M2F_ACTION}" method="POST">
			<input type="hidden" name="mode" value="pattern_matching" />
			<input type="hidden" name="id" value="{switch_patterns.patterns.id}" />
			<input type="submit" name="action" value="Delete" class="mainoption" />
			</form>
		</td>
		<td class="row2">{switch_patterns.patterns.description}</td>
		<td class="row2 code" nowrap>{switch_patterns.patterns.match}</td>
		<td class="row2 code" nowrap>{switch_patterns.patterns.replace}</td>
		<td class="row2" align="center">{switch_patterns.patterns.use_regexp}</td>
		<td class="row2 code" align="center">{switch_patterns.patterns.modifiers}</td>
		<td class="row2" align="center">{switch_patterns.patterns.target}</td>
	</tr>
 <!-- END patterns -->
	<tr>
		<td class="row2" colspan="9" align="center">&nbsp;</td>
	</tr>
 <!-- BEGIN internal_patterns -->
	<tr>
		<td align="center" class="row1" colspan="3">(internal m2f pattern)</td>
		<td class="row2">{switch_patterns.internal_patterns.description}</td>
		<td class="row2 code" nowrap>{switch_patterns.internal_patterns.match}</td>
		<td class="row2 code" nowrap>{switch_patterns.internal_patterns.replace}</td>
		<td class="row2" align="center">{switch_patterns.internal_patterns.use_regexp}</td>
		<td class="row2 code" align="center">{switch_patterns.internal_patterns.modifiers}</td>
		<td class="row2" align="center">{switch_patterns.internal_patterns.target}</td>
	</tr>
 <!-- END internal_patterns -->
	<tr>
		<td class="catBottom" colspan="9" align="center">&nbsp;</td>
	</tr>
</table>
<br /><br />
<!-- END switch_patterns -->

